DEFINT A-Z
DECLARE FUNCTION Ack% ()
DECLARE SUB Clock ()
DECLARE SUB Dat (D%)
DECLARE SUB Init ()
DECLARE SUB Sende (D%)
DECLARE SUB Start ()
DECLARE SUB Stopp ()
DECLARE SUB Warte ()

CLS
PRINT " -------- Data --------     Ack"
Init
Start
Sende 112                       'Display anprechen
Sende 128 + 64 + 32 + 0         'Subdevice 0 select
Sende 128 + 8 + 64              'Display an
Sende 0                         'Data Pointer auf 0
PRINT
INPUT "Anzeige: ", A$
A$ = A$ + "        "
FOR A = 1 TO 8
  SELECT CASE LCASE$(MID$(A$, A, 1))
    CASE "a": B$ = "11101111000000"
    CASE "b": B$ = "11110001010010"
    CASE "c": B$ = "10011100000000"
    CASE "d": B$ = "11110000010010"
    CASE "e": B$ = "10011110000000"
    CASE "f": B$ = "10001110000000"
    CASE "g": B$ = "10111101000000"
    CASE "h": B$ = "01101111000000"
    CASE "i": B$ = "00000000010010"
    CASE "j": B$ = "01111000000000"
    CASE "k": B$ = "00001110001001"
    CASE "l": B$ = "00011100000000"
    CASE "m": B$ = "01101100101000"
    CASE "n": B$ = "01101100100001"
    CASE "o": B$ = "11111100000000"
    CASE "p": B$ = "11001111000000"
    CASE "q": B$ = "11111100000001"
    CASE "r": B$ = "11001111000001"
    CASE "s": B$ = "10110111000000"
    CASE "t": B$ = "10000000010010"
    CASE "u": B$ = "01111100000000"
    CASE "v": B$ = "00001100001100"
    CASE "w": B$ = "01101100000101"
    CASE "x": B$ = "00000000101101"
    CASE "y": B$ = "00000000101010"
    CASE "z": B$ = "10010000001100"
    CASE "0": B$ = "11111100001100"
    CASE "1": B$ = "01100000001000"
    CASE "2": B$ = "11010001000100"
    CASE "3": B$ = "11110001000000"
    CASE "4": B$ = "00000111010010"
    CASE "5": B$ = "10010110000001"
    CASE "6": B$ = "10111111000000"
    CASE "7": B$ = "10000000001010"
    CASE "8": B$ = "11111111000000"
    CASE "9": B$ = "11110111000000"
    CASE "%": B$ = "00100100001100"
    CASE "/": B$ = "00000000001100"
    CASE "\": B$ = "00000000100001"
    CASE "+": B$ = "00000011010010"
    CASE "*": B$ = "00000011111111"
    CASE "-": B$ = "00000011000000"
    CASE "_": B$ = "00010000000000"
    CASE ELSE: B$ = "00000000000000"
  END SELECT
  B0 = 0
  B1 = 0
  FOR B = 1 TO 14
    IF MID$(B$, B, 1) = "1" THEN
      SELECT CASE B
        CASE 1: B0 = B0 + 8: B1 = B1 + 128
        CASE 2: B1 = B1 + 8
        CASE 3: B1 = B1 + 1
        CASE 4: B0 = B0 + 1: B1 = B1 + 16
        CASE 5: B0 = B0 + 16
        CASE 6: B0 = B0 + 128
        CASE 7: B0 = B0 + 32
        CASE 8: B1 = B1 + 4
        CASE 9: B0 = B0 + 2
        CASE 10: B1 = B1 + 32
        CASE 11: B1 = B1 + 2
        CASE 12: B0 = B0 + 64
        CASE 13: B0 = B0 + 4
        CASE 14: B1 = B1 + 64
      END SELECT
    END IF
  NEXT
  Sende B0
  Sende B1
NEXT
Stopp
Init

DEFSNG A-Z
FUNCTION Ack%
  OUT &H3FB, 0
  OUT &H3FC, 0
  Warte
  Ack = (INP(&H3FE) AND 128) / 128
  OUT &H3FC, 1
  Warte

END FUNCTION

SUB Clock
  OUT &H3FC, 0
  Warte
  OUT &H3FC, 1
  Warte
END SUB

SUB Dat (D%)
  OUT &H3FB, ABS(NOT -D%) * 64
  Warte
END SUB

SUB Init
  OUT &H3FB, 0
  OUT &H3FC, 0
  Warte
END SUB

SUB Sende (D%)
  FOR A = 7 TO 0 STEP -1
    Dat ((D% AND (2 ^ A)) / (2 ^ A))
    PRINT (D% AND (2 ^ A)) / (2 ^ A);
    Clock
  NEXT
  PRINT "-->"; Ack
END SUB

SUB Start
  OUT &H3FB, 64
  Warte
  OUT &H3FC, 1
  Warte
END SUB

SUB Stopp
  OUT &H3FC, 0
  Warte
  OUT &H3FB, 0
  Warte
END SUB

SUB Warte
  FOR A = 1 TO 100
  NEXT
END SUB

